// Robot.cpp: implementation of the CRobot class.
// Copyright: (c) 2006 Burkhard Wuensche
//////////////////////////////////////////////////////////////////////

#include <time.h>
#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glut.h>
#include "Robot.h"
#include "Geometry.h"
#include "Utilities.h"

#include <iostream>
#include <fstream>
using namespace std;

const double CRobot::rimRadius=0.02;
const double CRobot::basketRadius=0.2;
const double CRobot::basketHeight=0.4;
const double CRobot::armLength=0.6;
const double CRobot::bottomArmWidth=0.2;
const double CRobot::topArmWidth=0.1;

CRobot::CRobot()
{
	// initialise material properties
	no_shininess[0]=5;
	mat_specular[0]=0.1;
	mat_specular[1]=0.1;
	mat_specular[2]=0.1;
	mat_specular[3]=1;
	mat_ambient_and_diffuse[0]=0.15f;
	mat_ambient_and_diffuse[1]=0.25f;
	mat_ambient_and_diffuse[2]=0.8f;
	mat_ambient_and_diffuse[3]=1;

	// initialise geometry
	thetaMin=10.0;
	thetaMax=90.0;

	// initialise animation
	phi=0.0;
	theta=thetaMin;

	// initialise vertices basket
	// ===========================================================
	// = Q3(b): Define the vertices of the surface of revolution =
	// = representing the basket at the tip of the robot arm     =
	// ===========================================================
}

void CRobot::_initTexture()
{	// load net texture
	ifstream textureFile;
	char* fileName="Net.pgm";

	// =============================================================
	// = Q4: Load the texture image and initialise the texture map =
	// =============================================================
}

void CRobot::updateBasketPosition()
{
	float radius=2*armLength*sin(theta*Pi/180.0f)+basketRadius;
	basketCentre[0]=radius*sin((phi-90)*Pi/180.0f);
	basketCentre[1]=armLength;
	basketCentre[2]=radius*cos((phi-90)*Pi/180.0f);
}

void CRobot::_drawBasket()
{
	glShadeModel(GL_FLAT);

	// =====================================================
	// = Q3(b): Draw the basket as a surface of revolution =
	// =====================================================

	// ======================================================
	// = Q4: Texture map the basket with the image of a net =
	// ======================================================

	glShadeModel(GL_SMOOTH);
}

void CRobot::draw()
{
	glEnable(GL_NORMALIZE);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, no_shininess);
	glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_ambient_and_diffuse);

	// ==============================================================
	// = Q3: Implement a robot as defined in the assignment handout =
	// = Please use the parameters (phi, theta, armLength etc.)     =
	// = predefined in the file Robot.h                             =
	// = Use the method drawBasket() after drawing the torus        =
	// = defining the rim of the basket.                            =
	// ==============================================================

	glDisable(GL_NORMALIZE);
	glFlush();
}
